/// <reference types="react" />
import type { INPUT_METHOD } from '@atlaskit/editor-common/analytics';
import type { ExtractInjectionAPI } from '@atlaskit/editor-common/types';
import type { ToolbarButtonRef } from '@atlaskit/editor-common/ui-menu';
import type { HighlightPlugin } from '../../plugin';
type UseDropdownEventArgs = {
    setIsDropdownOpen: (isOpen: boolean) => void;
    isDropdownOpen: boolean;
    pluginInjectionApi: ExtractInjectionAPI<HighlightPlugin> | undefined;
    toolbarItemRef: React.RefObject<ToolbarButtonRef>;
};
export declare const useDropdownEvents: (args: UseDropdownEventArgs) => {
    handleClick: () => void;
    handleKeyDown: (event: React.KeyboardEvent) => void;
    handleClickOutside: () => void;
    handleEscapeKeydown: () => void;
    handleColorChange: ({ color, inputMethod }: {
        color: string;
        inputMethod: INPUT_METHOD;
    }) => void;
    isOpenedByKeyboard: boolean;
};
export {};
